(function ($) {
	let ope_multistep_count = 0;
	function getCAPCHACODE() {
		let url = ope_form_object.ajaxurl,
			secureNonce = ope_form_object.form_nonce;
		jQuery
			.ajax({
				url: url,
				method: "POST",
				data: {
					action: "get_CAPCHACODE",
					security: secureNonce,
					id: jQuery(".verification-graph").data("string"),
				},
			})
			.done(function (res) {
				if (res) {
					if (jQuery(".verification-graph").find("img").length == 0) {
						jQuery(".verification-graph").html(
							'<img src="data:image/png;base64, ' + res + ' ">'
						);
						jQuery(".verification-graph").removeClass("hold");
					} else {
						jQuery(".verification-graph")
							.find("img")
							.attr("src", "data:image/png;base64," + res);
						jQuery(".verification-graph").removeClass("hold");
					}
				}
			})
			.fail(function (err, textStatus, errorThrown) {
				alert(errorThrown + " for getting Verification Code");
			});
	}
	let check_CAPCHACODE_TIMER = 0;
	function checkCAPCHACODE() {
		if (!jQuery(".opeform-verification").hasClass("hold")) {
			return;
		}
		clearTimeout(check_CAPCHACODE_TIMER);
		check_CAPCHACODE_TIMER = setTimeout(function () {
			let url = ope_form_object.ajaxurl,
				secureNonce = ope_form_object.form_nonce;
			jQuery
				.ajax({
					url: url,
					method: "POST",
					data: {
						action: "check_CAPCHACODE",
						security: secureNonce,
						id: jQuery(".opeform-verification input").data("id"),
						value: jQuery(".opeform-verification input").val().trim(),
					},
				})
				.done(function (res) {
					res = JSON.parse(res);
					if (
						jQuery(".ope-form .opeform-verification input").val().trim()
							.length == 8
					) {
						if (res.match == 1) {
							jQuery(".ope-form .opeform-verification-wrapper i")
								.removeClass("waiting")
								.removeClass("not-matched")
								.addClass("matched");
							if (ope_form_object.check_immediately != 1) {
								hideErrorMessage(
									jQuery(".ope-form .opeform-item .opeform-verification input")
								);
							}
						} else {
							jQuery(".ope-form .opeform-verification-wrapper i")
								.removeClass("waiting")
								.addClass("matched")
								.addClass("not-matched");
							errorMessage(
								ope_form_object.verification_failed,
								jQuery(".ope-form .opeform-item .opeform-verification input")
							);
						}
					}
					jQuery(".opeform-verification").removeClass("hold");
				})
				.fail(function () {
					jQuery(".opeform-verification").removeClass("hold");
				});
		}, 500);
	}
	function checkVerificationCode() {
		jQuery(".opeform-verification input")
			.off()
			.on("input", function () {
				if (jQuery(this).val().length == 8) {
					jQuery(".opeform-verification").addClass("hold");
					jQuery(
						".ope-form .opeform-item .opeform-verification-wrapper i"
					).addClass("waiting");
					checkCAPCHACODE();
				} else {
					jQuery(".opeform-verification").removeClass("hold");
					jQuery(".ope-form .opeform-verification-wrapper i")
						.removeClass("waiting")
						.removeClass("not-matched")
						.removeClass("matched");
				}
			});
	}
	function capchacode() {
		if (jQuery(".verification-graph").length > 0) {
			getCAPCHACODE();
			jQuery(".verification-graph")
				.off()
				.on("click", function () {
					jQuery(".verification-graph").find("img").remove();
					jQuery(this).addClass("hold");
					getCAPCHACODE();
					jQuery(".opeform-verification").addClass("hold");
					checkCAPCHACODE();
				});
			checkVerificationCode();
		}
	}
	function REFRESHcapchacode() {
		getCAPCHACODE();
		jQuery(".verification-graph")
			.off()
			.on("click", function () {
				jQuery(".verification-graph").find("img").remove();
				jQuery(".verification-graph").addClass("hold");
				getCAPCHACODE();
			});
	}
	function errorMessage($text, $target) {
		if ($target.parents(".opeform-item").hasClass("has-select")) {
			$target.parents(".opeform-item").addClass("error-select");
		}
		if ($target.parents(".opeform-item").hasClass("has-checkbox")) {
			$target.parents(".opeform-item").addClass("expand");
			$target.parents(".opeform-item").find("input").addClass("error");
		} else {
			$target.addClass("error");
		}
		if ($target.parents(".opeform-item").find(".err-msg-content").length <= 0) {
			$target
				.parents(".opeform-item")
				.prepend('<div class="err-msg-content">' + $text + "</div>");
			$target
				.parents(".opeform-item")
				.find(".err-msg-content")
				.addClass("show");
		} else {
			$target.parents(".opeform-item").find(".err-msg-content").html($text);
			$target
				.parents(".opeform-item")
				.find(".err-msg-content")
				.addClass("show");
		}
	}
	function hideErrorMessage($target) {
		if ($target.hasClass("error")) {
			$target.removeClass("error");
			$target
				.parents(".opeform-item")
				.find(".err-msg-content")
				.removeClass("show");
			if ($target.parents(".opeform-item").hasClass("has-checkbox")) {
				$target.parents(".opeform-item").removeClass("expand");
			}
			if ($target.parents(".opeform-item").hasClass("has-select")) {
				$target.parents(".opeform-item").removeClass("error-select");
			}
		}
	}
	function verifyText() {
		jQuery('.opeform-item [type="text"]').each(function () {
			let $this = jQuery(this);
			$this.on("blur", function () {
				if (
					$this.val().trim().length <= 0 &&
					$this.attr("required") != undefined
				) {
					errorMessage(ope_form_object.required, $this);
				}
			});
			$this.on("input", function () {
				hideErrorMessage($this);
			});
		});
	}
	function verifyImage() {
		jQuery('.opeform-item .upload-image-content [type="ope_image"]').each(
			function () {
				let $this = jQuery(this);
				if (
					$this.val().trim().length <= 0 &&
					$this.attr("required") != undefined
				) {
					errorMessage(ope_form_object.required, $this);
				} else {
					hideErrorMessage($this);
				}
			}
		);
	}
	function ValidateEmail(mail) {
		if (
			/^[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/.test(
				mail
			)
		) {
			return true;
		} else {
			return false;
		}
	}
	function verifyEmail() {
		jQuery('.opeform-item [type="email"]').each(function () {
			let $this = jQuery(this);
			$this.on("blur", function () {
				if (
					$this.val().trim().length <= 0 &&
					$this.attr("required") != undefined
				) {
					errorMessage(ope_form_object.required, $this);
					return;
				}
				if ($this.val().trim().length > 0) {
					let $format_email = ValidateEmail($this.val().trim());
					if ($format_email == true) {
						hideErrorMessage($this);
					} else {
						errorMessage(ope_form_object.invalid_email, $this);
					}
					if ($this.attr("confirm") != undefined) {
						if (
							$this.val().trim() !==
							jQuery('.opeform-item [type="email"]:not([confirm])').val().trim()
						) {
							errorMessage(ope_form_object.email_not_matched, $this);
						}
					} else {
						if (
							$this
								.parents(".item")
								.next(".item")
								.find('[type="email"][confirm]').length > 0
						) {
							if (
								$this.val().trim() ==
								jQuery(this)
									.parents(".item")
									.next(".item")
									.find('[type="email"][confirm]')
									.val()
									.trim()
							) {
								hideErrorMessage($this);
								hideErrorMessage(
									$this
										.parents(".item")
										.next(".item")
										.find('[type="email"][confirm]')
								);
							}
						}
					}
				}
				if ($this.val().trim().length <= 0) {
					if ($this.attr("confirm") != undefined) {
						if (
							$this.val().trim() !==
							jQuery('.opeform-item [type="email"]:not([confirm])').val().trim()
						) {
							errorMessage(ope_form_object.email_not_matched, $this);
						}
					}
				}
			});
			$this.on("input", function () {
				hideErrorMessage($this);
			});
		});
	}
	function ValidateTel(tel) {
		tel = tel.replace(/[━.*‐.*―.*－.*\-.*ー.*\-]/gi, "");
		if (
			/^\d{10}$/.test(tel) ||
			/^\d{11}$/.test(tel) ||
			/^\d{12}$/.test(tel) ||
			/^\d{13}$/.test(tel) ||
			/^\d{14}$/.test(tel) ||
			/^\d{15}$/.test(tel)
		) {
			return true;
		} else {
			return false;
		}
	}
	function verifyTel() {
		jQuery('.opeform-item [type="tel"]').each(function () {
			let $this = jQuery(this);
			$this.on("blur", function () {
				if (
					$this.val().trim().length <= 0 &&
					$this.attr("required") != undefined
				) {
					errorMessage(ope_form_object.required, $this);
					return;
				}
				if ($this.val().trim().length > 0) {
					let $format_tel = ValidateTel($this.val().trim());
					if ($format_tel == true) {
						hideErrorMessage($this);
					} else {
						errorMessage(ope_form_object.invalid_phone, $this);
					}
				}
			});
			$this.on("input", function () {
				hideErrorMessage($this);
			});
		});
	}
	function verifyTextarea() {
		jQuery(".opeform-item textarea").each(function () {
			let $this = jQuery(this);
			$this.on("blur", function () {
				if (
					$this.val().trim().length <= 0 &&
					$this.attr("required") != undefined
				) {
					errorMessage(ope_form_object.required, $this);
					return;
				}
			});
			$this.on("input", function () {
				hideErrorMessage($this);
			});
		});
	}
	const FileSizeValidation = ($file, $maxSize, $types) => {
		if ($file[0].files.length > 0) {
			for (let i = 0; i <= $file[0].files.length - 1; i++) {
				let filesize = $file[0].files.item(i).size;
				if (filesize >= $maxSize) {
					errorMessage(ope_form_object.fileTooBig, $file);
					$file.val("");
					$file.parents(".opeform-item").removeClass("has-file");
					$file.parents(".opeform-item").find(".upload-file-name").html("");
					return;
				} else {
					hideErrorMessage($file);
					if ($types != "") {
						$types = $types.replaceAll(".", "");
						let validExt = $types.split(",");
						var extension = $file[0].files.item(i).type.split("/")[1];
						extension = extension || [];
						const contains = validExt.some((element) => {
							if (extension.includes(element)) {
								return true;
							}
							return false;
						});
						if (!contains) {
							$file.parents(".opeform-item").removeClass("has-file");
							$file.parents(".opeform-item").find(".upload-file-name").html("");
							errorMessage(ope_form_object.fileTypeError, $file);
							$file.val("");
							return;
						} else {
							hideErrorMessage($file);
						}
					}
					$file.parents(".opeform-item").addClass("has-file");
					$file
						.parents(".opeform-item")
						.find(".upload-file-name")
						.html($file[0].files.item(i).name);
					$file
						.parents(".opeform-item")
						.find(".remove-file")
						.off()
						.on("click", function () {
							$file.parents(".opeform-item").removeClass("has-file");
							$file.parents(".opeform-item").find(".upload-file-name").html("");
							$file.val("");
						});
				}
			}
		}
	};
	function verifyFile() {
		jQuery('.opeform-item [type="file"]').each(function () {
			let $this = jQuery(this);
			let $maxSize = $this.attr("size");
			let $types = $this.attr("accept") ? $this.attr("accept") : "";
			$this.on("change", function () {
				FileSizeValidation($this, $maxSize, $types);
			});
		});
	}
	function verifyCheckbox() {
		jQuery(".opeform-item.has-checkbox").each(function () {
			let $quantity = jQuery(this).data("quantity");
			if ($quantity == "" && $quantity !== 0) {
				$quantity = 1;
			}
			jQuery(this)
				.find("input")
				.each(function () {
					let $this = jQuery(this);
					$this.on("change", function () {
						if (
							$this.parents(".opeform-item").find("input:checked").length >=
							$quantity
						) {
							$this
								.parents(".opeform-item")
								.find("input:not(:checked)")
								.parent("label")
								.addClass("disable");
							hideErrorMessage($this);
						} else {
							$this
								.parents(".opeform-item")
								.find(".disable")
								.removeClass("disable");
							if ($this[0].checked) {
								hideErrorMessage($this);
							} else {
								if (
									$this.parents(".opeform-item").find("input:checked").length <=
										0 &&
									$this.parents(".opeform-item").attr("required") != undefined
								) {
									errorMessage(ope_form_object.required, $this);
								}
							}
						}
					});
				});
		});
	}
	function radioBox() {
		jQuery(".opeform-item.has-radiobox").each(function () {
			jQuery(this)
				.find("input")
				.each(function () {
					let $this = jQuery(this);
					$this.on("change", function () {
						jQuery(this)
							.parent("label")
							.siblings("label")
							.find("input")
							.prop("checked", false);
					});
				});
		});
	}
	function formSelect() {
		jQuery(".opeform-item.has-select").each(function () {
			let $this = jQuery(this);
			$this.find(".selected-text").on("click", function () {
				jQuery(this).toggleClass("active");
				$this.find(".select-wrapper").toggleClass("show");
				if ($this.find(".select-wrapper").hasClass("show")) {
					$this.find(".select-wrapper")[0].scrollTo(0, 0);
				}
				if (
					$this.attr("required") !== undefined &&
					!jQuery(this).hasClass("active")
				) {
					if ($this.find('input[type="hidden"]').val().trim() == "") {
						errorMessage(ope_form_object.required, $this.find("input"));
					}
				}
			});
			$this
				.find(".select-wrapper")
				.find("[data-value]")
				.on("click", function () {
					$this.find('input[type="hidden"]').val(jQuery(this).data("value"));
					$this.find(".selected-text").html(jQuery(this).data("value"));
					$this.find(".select-wrapper").removeClass("show");
					$this.find(".selected-text").removeClass("active");
					if ($this.attr("required") !== undefined) {
						if ($this.find('input[type="hidden"]').val().trim() != "") {
							hideErrorMessage($this.find("input"));
						}
					}
				});
			jQuery(document).on("click", function (e) {
				if (e.target != $this.find(".selected-text")[0]) {
					if ($this.find(".selected-text").hasClass("active")) {
						$this.find(".select-wrapper").removeClass("show");
						$this.find(".selected-text").removeClass("active");
						if (ope_form_object.check_immediately == 1) {
							if ($this.attr("required") !== undefined) {
								if ($this.find('input[type="hidden"]').val().trim() == "") {
									errorMessage(ope_form_object.required, $this.find("input"));
								}
							}
						}
					}
				}
			});
		});
	}
	function opeFormConfirmVeriry($target) {
		let $form = $target.parents(".ope-form");
		let $flag = false;
		$form.find("input[required]").each(function () {
			if (jQuery(this).val().trim() == "" || jQuery(this).hasClass("error")) {
				$flag = true;
				errorMessage(ope_form_object.required, jQuery(this));
			}
		});
		$form.find("textarea[required]").each(function () {
			if (jQuery(this).val().trim() == "" || jQuery(this).hasClass("error")) {
				$flag = true;
				errorMessage(ope_form_object.required, jQuery(this));
			}
		});
		$form.find(".opeform-verification input[required]").each(function () {
			if (
				jQuery(this).val().trim().length > 0 &&
				jQuery(this).val().trim().length !== 8
			) {
				$flag = true;
				errorMessage(ope_form_object.error, jQuery(this));
			}
		});
		$form.find(".has-select[required] input").each(function () {
			if (jQuery(this).val().trim() == "") {
				$flag = true;
				errorMessage(ope_form_object.required, jQuery(this));
			}
		});
		$form.find(".has-checkbox[required]").each(function () {
			if (jQuery(this).find("input:checked").length <= 0) {
				$flag = true;
				errorMessage(
					ope_form_object.required,
					jQuery(this).find("input").eq(0)
				);
			}
		});
		if (ope_form_object.check_immediately != 1) {
			$form
				.find(".opeform-item")
				.find('[type="tel"]')
				.each(function () {
					let $this = jQuery(this);
					if (
						$this.val().trim().length <= 0 &&
						$this.attr("required") != undefined
					) {
						$flag = true;
						errorMessage(ope_form_object.required, $this);
					}
					if ($this.val().trim().length > 0) {
						let $format_tel = ValidateTel($this.val().trim());
						if ($format_tel != true) {
							$flag = true;
							errorMessage(ope_form_object.invalid_phone, $this);
						}
					}
				});
			$form
				.find(".opeform-item")
				.find('[type="email"]')
				.each(function () {
					let $this = jQuery(this);
					if (
						$this.val().trim().length <= 0 &&
						$this.attr("required") != undefined
					) {
						$flag = true;
						errorMessage(ope_form_object.required, $this);
					}
					if ($this.val().trim().length > 0) {
						let $format_email = ValidateEmail($this.val().trim());
						if ($format_email == true) {
							//
						} else {
							$flag = true;
							errorMessage(ope_form_object.invalid_email, $this);
						}
						if ($this.attr("confirm") != undefined) {
							if (
								$this.val().trim() !==
								$form
									.find(".opeform-item")
									.find('[type="email"]:not([confirm])')
									.val()
									.trim()
							) {
								$flag = true;
								errorMessage(ope_form_object.email_not_matched, $this);
							}
						}
					}
					if ($this.val().trim().length <= 0) {
						if ($this.attr("confirm") != undefined) {
							if (
								$this.val().trim() !==
								$form
									.find(".opeform-item")
									.find('[type="email"]:not([confirm])')
									.val()
									.trim()
							) {
								$flag = true;
								errorMessage(ope_form_object.email_not_matched, $this);
							}
						}
					}
				});
		}
		return $flag;
	}
	function opeFormConfirm() {
		jQuery('.opeform-submit[data-action="confirm"]')
			.off()
			.on("click", function () {
				if (ope_form_object.check_immediately != 1) {
					verifyText();
					verifyImage();
					verifyEmail();
					verifyTel();
					verifyTextarea();
					verifyCheckbox();
				}
				let $result = opeFormConfirmVeriry(jQuery(this));
				if (!$result) {
					let $first_form_item =
						jQuery(this).parents(".ope-form").offset().top - 130;
					setTimeout(function () {
						jQuery("html,body")[0].scrollTo({
							top: $first_form_item,
							behavior: "smooth",
						});
					}, 50);
					ope_multistep_count++;
					doConfirm(jQuery(this));
				} else {
					let $first_error_item =
						jQuery(".opeform-item .error").eq(0).offset().top - 130;
					setTimeout(function () {
						jQuery("html,body")[0].scrollTo({
							top: $first_error_item,
							behavior: "smooth",
						});
					}, 50);
				}
			});
	}
	function doConfirm($element) {
		let $cloned_id = $element.parents(".ope-form").data("form-id");
		let $cloned = jQuery("[data-form-id=" + $cloned_id + "].cloned");
		$cloned
			.addClass("confirming")
			.siblings('[data-form-id="' + $cloned_id + '"]')
			.addClass("hide");
		jQuery("body").addClass("ope-form-step-2").removeClass("ope-form-step-1");
		$element
			.parents(".ope-form")
			.find('input[type="text"]')
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				if (
					jQuery(this)
						.parents(".control")
						.find('[data-id="' + $id + '"]').length > 1
				) {
					let $string = $cloned.find('[data-target="' + $id + '"]').html();
					$string += $val;
					if (ope_form_object.name_format == "EN") {
						$string += " ";
					}
					if (ope_form_object.name_format == "JA") {
						$string += "　";
					}
					$cloned.find('[data-target="' + $id + '"]').html($string);
				} else {
					$cloned.find('[data-target="' + $id + '"]').html($val);
				}
			});
		$element
			.parents(".ope-form")
			.find('input[type="file"]')
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				$cloned.find('[data-target="' + $id + '"]').html($val);
			});
		$element
			.parents(".ope-form")
			.find('input[type="ope_image"]')
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				$cloned
					.find('[data-target="' + $id + '"]')
					.html('<img src="' + $val + '">');
			});
		$element
			.parents(".ope-form")
			.find('input[type="tel"]')
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				$cloned.find('[data-target="' + $id + '"]').html($val);
			});
		$element
			.parents(".ope-form")
			.find('input[type="email"]')
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				$cloned.find('[data-target="' + $id + '"]').html($val);
			});
		$element
			.parents(".ope-form")
			.find("textarea")
			.each(function () {
				let $val = jQuery(this).val();
				let $id = jQuery(this).data("id");
				$cloned
					.find('[data-target="' + $id + '"]')
					.html($val.replace(/\n/g, "<br>"));
			});
		$element
			.parents(".ope-form")
			.find('input[type="hidden"]')
			.each(function () {
				if (jQuery(this).parents(".select").length > 0) {
					let $val = jQuery(this)
						.parents(".select")
						.find(".selected-text")
						.html();
					let $id = jQuery(this).data("id");
					$val = $val ? $val : "";
					$cloned.find('[data-target="' + $id + '"]').html($val);
				}
			});
		$element
			.parents(".ope-form")
			.find(".opeform-item")
			.each(function () {
				if (jQuery(this).hasClass("has-checkbox")) {
					let $val = "";
					jQuery(this)
						.find('input[type="checkbox"]')
						.each(function () {
							if (jQuery(this).prop("checked") == true) {
								let $checked = "<span>" + jQuery(this).val() + "</span>";
								$val += $checked;
							}
						});
					let $id = jQuery(this)
						.find("label")
						.eq(0)
						.find('input[type="checkbox"]')
						.data("id");
					$val = $val ? $val : "";
					$cloned.find('[data-target="' + $id + '"]').html($val);
				}
			});
		$element
			.parents(".ope-form")
			.find(".opeform-item")
			.each(function () {
				if (jQuery(this).hasClass("has-radiobox")) {
					let $val = "";
					jQuery(this)
						.find('input[type="radio"]')
						.each(function () {
							if (jQuery(this).prop("checked") == true) {
								let $checked = "<span>" + jQuery(this).val() + "</span>";
								$val += $checked;
							}
						});
					let $id = jQuery(this)
						.find("label")
						.eq(0)
						.find('input[type="radio"]')
						.data("id");
					$val = $val ? $val : "";
					$cloned.find('[data-target="' + $id + '"]').html($val);
				}
			});
	}
	async function renewToken() {
		jQuery('[data-action="confirm"]').addClass("waiting");
		let url = ope_form_object.ajaxurl,
			secureNonce = ope_form_object.form_nonce;
		let data = { s: secureNonce, action: "renewToken" };
		const response = await fetch(url, {
			method: "POST",
			mode: "same-origin",
			cache: "no-cache",
			redirect: "follow",
			referrerPolicy: "same-origin",
			headers: {
				"Content-Type": "application/x-www-form-urlencoded",
				"Cache-Control": "no-cache",
			},
			credentials: "same-origin",
			body: new URLSearchParams(data),
		});
		const jsonData = await response.json();
		if (jsonData) {
			jQuery('[name="ope_form_token"]').val(jsonData.token);
			jQuery('[data-action="confirm"]').removeClass("waiting");
		}
	}
	function cloneForm() {
		const $clone = jQuery(".ope-form").clone().addClass("cloned");
		const $item_count = $clone.find(".item").length;
		let $i = 0;
		$clone.find(".control").each(function () {
			$i++;
			if (jQuery(this).find(".opeform-verification").length > 0) {
				jQuery(this).parents(".item").remove();
			}
			if (
				jQuery(this).find('input[type="email"]').attr("confirm") != undefined
			) {
				jQuery(this).parents(".item").remove();
			}
			let $id = jQuery(this).find("[data-id]").data("id");
			jQuery(this).attr("data-target", $id);
			let $type = jQuery(this).find("[type]").attr("type");
			if ($type) {
				jQuery(this).attr("data-type", $type);
			}
			let $name = jQuery(this).find("[data-item-name]").data("item-name");
			jQuery(this).attr("data-target-name", $name).html("");
			if ($i == $item_count) {
				jQuery(this).html(
					'<div class="opeform-item multi-btn"><div class="opeform-submit" data-action="prev"><span>' +
						ope_form_object.prev_btn_text +
						'</span></div><div class="opeform-submit" data-progress="0%" data-action="send"><span>' +
						ope_form_object.send_btn_text +
						"</span></div></div>"
				);
			}
		});
		$clone.prepend(
			'<div class="note">' + $clone.data("confirm-page-text") + "</div>"
		);
		$clone.insertAfter(jQuery(".ope-form"));
		jQuery('[data-action="send"]').on("click", function (e) {
			let $this_id = jQuery(this).data("form-id");
			let $this = jQuery(this)
				.parents(".cloned")
				.prev('[data-form-id="' + $this_id + '"]');
			let $result = opeFormConfirmVeriry($this);
			if (!$result) {
				ope_multistep_count++;
				doSend(jQuery(this), e);
				jQuery(this).addClass("waiting");
				jQuery(this).addClass("progressing");
			}
		});
		jQuery('[data-action="prev"]').on("click", function () {
			let $cloned_id = jQuery(this).parents(".ope-form").data("form-id");
			let $cloned = jQuery("[data-form-id=" + $cloned_id + "].cloned");
			$cloned
				.removeClass("confirming")
				.siblings('[data-form-id="' + $cloned_id + '"]')
				.removeClass("hide");
			jQuery("body").addClass("ope-form-step-1").removeClass("ope-form-step-2");
			$cloned.find("[data-target]").html("");
		});
	}
	const ajaxSendEmail = async ($data, $obj, e) => {
		if (jQuery('[name="ope_user_name"]').length > 0) {
			location.reload();
			return;
		}
		let $behavior = {};
		$behavior["click_action"] = true;
		$behavior["multistep_count"] = ope_multistep_count;
		$behavior["ua"] = navigator.userAgent;
		if (jQuery(".ope-form .opeform-verification input").length > 0) {
			$behavior["request_code"] = jQuery(
				".ope-form .opeform-verification input"
			)
				.val()
				.trim();
		}
		$behavior["current_page"] = jQuery("[data-form-category]").data(
			"form-category"
		);
		$behavior["language"] = navigator.language;
		$behavior["logical_processors"] = navigator.hardwareConcurrency;
		$behavior["screen_size"] = window.innerWidth + "X" + window.innerHeight;
		var x = e.pageX - jQuery(e.currentTarget).offset().left;
		var y = e.pageY - jQuery(e.currentTarget).offset().top;
		$behavior["click_position"] = "x:" + x + "||y:" + y;
		$behavior = JSON.stringify($behavior);
		let url = ope_form_object.ajaxurl,
			secureNonce = ope_form_object.form_nonce;
		let from_name = "";
		if (
			$obj.parents(".ope-form").prev(".ope-form").find("input[data-from-name]")
				.length > 0 &&
			$obj
				.parents(".ope-form")
				.prev(".ope-form")
				.find("input[data-from-name]")
				.val()
				.trim() != ""
		) {
			$obj
				.parents(".ope-form")
				.prev(".ope-form")
				.find("input[data-from-name]")
				.each(function () {
					from_name += jQuery(this).val().trim();
				});
		}
		let vid = $obj
			.parents(".ope-form")
			.prev(".ope-form")
			.find(".opeform-verification")
			.find("input");
		let verificationInput = $obj
			.parents(".ope-form")
			.prev(".ope-form")
			.find(".opeform-verification")
			.find("input");
		let dataFromEmail = $obj
			.parents(".ope-form")
			.prev(".ope-form")
			.find("input[data-from-email]");
		let formCat = $obj.parents(".ope-form").data("form-category");
		let data = {
			nonce: secureNonce,
			name: jQuery('[name="ope_user_name"]').val()
				? jQuery('[name="ope_user_name"]').val()
				: "-/-",
			data: $data,
			action: "send_email",
			behavior: $behavior,
			id: vid.length > 0 ? vid.data("id") : "",
			value: verificationInput.length > 0 ? verificationInput.val().trim() : "",
			from_email: dataFromEmail.length > 0 ? dataFromEmail.val().trim() : "",
			from_name: from_name.length > 0 ? from_name : "",
			cat: formCat.length > 0 ? formCat : "",
			token: jQuery('[name="ope_form_token"]').val(),
		};
		let $files = new FormData();
		for (var key in data) {
			$files.append(key, data[key]);
		}
		let $item_file = $obj.parents(".cloned").find('[data-type="file"]');
		let $data_file = [];
		$item_file.each(function () {
			if (jQuery(this).html().trim() != "") {
				let $key = jQuery(this).data("target-name");
				$data_file.push($key);
			}
		});
		$data_file = JSON.stringify($data_file);
		$files.append("fileNames", $data_file);
		let $fileItem = $obj
			.parents(".cloned")
			.siblings(".ope-form")
			.find('[type="file"]');
		if ($fileItem.length > 0) {
			$fileItem.each(function () {
				if (jQuery(this).val() != "") {
					let $key = jQuery(this).data("item-name");
					let $value = jQuery(this)[0].files[0];
					$files.append($key, $value);
				}
			});
		}
		jQuery
			.ajax({
				xhr: function () {
					let xhr = new window.XMLHttpRequest();
					xhr.upload.addEventListener(
						"progress",
						function (evt) {
							if (evt.lengthComputable) {
								let percentComplete = evt.loaded / evt.total;
								let percentage = parseInt(percentComplete * 100);
								$obj.attr("data-progress", percentage + "%");
								if (percentComplete === 1) {
									$obj.removeClass("progressing");
								}
							}
						},
						false
					);
					xhr.addEventListener(
						"progress",
						function (evt) {
							if (evt.lengthComputable) {
								let percentComplete = evt.loaded / evt.total;
								let percentage = parseInt(percentComplete * 100);
								$obj.attr("data-progress", percentage + "%");
								if (percentComplete === 1) {
									$obj.removeClass("progressing");
								}
							}
						},
						false
					);
					return xhr;
				},
				url: url,
				type: "POST",
				data: $files,
				cache: false,
				processData: false,
				contentType: false,
			})
			.done(function (response) {
				response = JSON.parse(response);
				if (response.captcha == "captcha_not_mateched") {
					REFRESHcapchacode();
					checkCAPCHACODE();
					$obj.attr("data-progress", "0%");
					$obj.removeClass("waiting");
					alert(ope_form_object.verification_failed);
				}
				if (response.to.status == "success") {
					showSuccessBox($obj.parents(".ope-form").data("thanks-page-text"));
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="text"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="ope_image"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".img-temp-content")
						.each(function () {
							jQuery(this)
								.removeClass("has-image")
								.find("img")
								.attr(
									"src",
									"data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7"
								);
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="file"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".has-file")
						.each(function () {
							jQuery(this).removeClass("has-file");
							jQuery(this).find(".upload-file-name").html("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="email"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="tel"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="number"]')
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find("textarea")
						.each(function () {
							jQuery(this).val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find('input[type="checkbox"]')
						.each(function () {
							jQuery(this).prop("checked", false);
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".has-checkbox")
						.each(function () {
							jQuery(this).find(".disable").removeClass("disable");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".has-select")
						.each(function () {
							jQuery(this).find("input").val("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".selected-text")
						.each(function () {
							jQuery(this).html("");
						});
					$obj
						.parents(".ope-form")
						.prev(".ope-form")
						.find(".text-remaining")
						.each(function () {
							jQuery(this).find(".r").html("0");
						});
					$obj.removeClass("waiting");
					jQuery("body")
						.removeClass("ope-form-step-3")
						.removeClass("ope-form-step-2")
						.removeClass("ope-form-step-1");
					jQuery("html,body")[0].scrollTo(0, 0);
					if (jQuery(".verification-graph").length > 0) {
						getCAPCHACODE();
						checkCAPCHACODE();
					}
				}
				if (response.to.status == "failed") {
					if (response.to.code.includes("Authentication Failed")) {
						if (response.to.code.includes("Token")) {
							renewToken();
							alert(ope_form_object.send_failed);
							jQuery("html,body")[0].scrollTo(0, 0);
							if (jQuery(".verification-graph").length > 0) {
								jQuery(".opeform-verification").find("input").val("");
								getCAPCHACODE();
								checkCAPCHACODE();
							}
							$obj.removeClass("waiting");
							jQuery("body")
								.removeClass("ope-form-step-3")
								.removeClass("ope-form-step-2")
								.addClass("ope-form-step-1");
							jQuery(".ope-form.cloned")
								.removeClass("confirming")
								.siblings()
								.removeClass("hide");
							opeFormConfirm();
						} else {
							alert(ope_form_object.auth_error);
							location.reload();
						}
					}
					if (response.to.code == "Invalid String") {
						alert(ope_form_object.invalid_string);
						if (jQuery(".verification-graph").length > 0) {
							jQuery(".opeform-verification").find("input").val("");
							getCAPCHACODE();
							checkCAPCHACODE();
						}
						$obj.removeClass("waiting");
						jQuery("body")
							.removeClass("ope-form-step-3")
							.removeClass("ope-form-step-2")
							.addClass("ope-form-step-1");
						jQuery(".ope-form.cloned")
							.removeClass("confirming")
							.siblings()
							.removeClass("hide");
						opeFormConfirm();
					}
				}
			})
			.fail(function (a, b, c) {
				alert(ope_form_object.send_failed);
				location.reload();
				return;
			});
	};
	let redirectTimer = 0;
	function showSuccessBox($thanks_message) {
		if (jQuery(".ope-form-success-box").length <= 0) {
			jQuery("body").prepend(
				'<div class="ope-form-success-box"><div class="icon"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path fill="currentColor" d="M438.6 105.4C451.1 117.9 451.1 138.1 438.6 150.6L182.6 406.6C170.1 419.1 149.9 419.1 137.4 406.6L9.372 278.6C-3.124 266.1-3.124 245.9 9.372 233.4C21.87 220.9 42.13 220.9 54.63 233.4L159.1 338.7L393.4 105.4C405.9 92.88 426.1 92.88 438.6 105.4H438.6z"/></svg></div><div class="text">' +
					$thanks_message +
					'</div><div class="btn-to-home"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 48 48"><path fill="currentColor" d="M12 36V12h3v24Zm22.35-.15-11.7-11.7 11.7-11.7 2.15 2.15-9.55 9.55 9.55 9.55Z"/></svg>' +
					ope_form_object.return_btn_text +
					'</div><div class="timer"><i id="ope_timer"></i></div></div>'
			);
			jQuery(".ope-form.cloned")
				.removeClass("confirming")
				.siblings()
				.removeClass("hide");
			jQuery(".btn-to-home").on("click", function () {
				clearInterval(redirectTimer);
				jQuery(".ope-form-success-box").fadeOut(200, function () {
					jQuery(".ope-form-success-box").remove();
				});
			});
			if (ope_form_object.auto_return == 1) {
				let timeleft = ope_form_object.auto_return_timeleft
					? ope_form_object.auto_return_timeleft
					: 10;
				jQuery("#ope_timer").html(timeleft);
				clearInterval(redirectTimer);
				redirectTimer = setInterval(function () {
					timeleft -= 1;
					if (timeleft <= 0) {
						location.reload();
					}
					jQuery("#ope_timer").off().html(timeleft);
				}, 1000);
			}
		}
	}
	function doSend($element, e) {
		let $item = $element
			.parents(".cloned")
			.find("[data-target]")
			.not('[data-type="file"]');
		let $data = [];
		$item.each(function () {
			let $key = jQuery(this).data("target-name");
			let $value = jQuery(this).html();
			$value = $value.replaceAll("</span><span>", " | ");
			$value = $value.replaceAll("</span>", "");
			$value = $value.replaceAll("<span>", "");
			let regex = /<br\s*[\/]?>/gi;
			$value = $value.replaceAll(regex, "\n");
			let $obj = { key: $key, value: $value };
			$data.push($obj);
		});
		$data = JSON.stringify($data);
		ajaxSendEmail($data, $element, e);
		jQuery("body").addClass("ope-form-step-3").removeClass("ope-form-step-2");
	}
	function textRemaing() {
		jQuery(".ope-form .text-remaining .total").each(function () {
			let $this = jQuery(this);
			$this.html(
				$this.parents(".opeform-item").find("textarea").attr("maxlength")
			);
			$this
				.parents(".opeform-item")
				.find("textarea")
				.on("input", function () {
					let $remaining =
						parseInt(
							$this.parents(".opeform-item").find("textarea").attr("maxlength")
						) -
						parseInt(
							$this.parents(".opeform-item").find("textarea").val().length
						);
					$this.parent(".text-remaining").find(".r").html($remaining);
				});
		});
	}
	function bodyClassControl() {
		jQuery("body").addClass("has-ope-form");
		jQuery("body").addClass("ope-form-step-1");
	}
	function zIndexControl() {
		jQuery(".ope-form .item").on("click", function () {
			jQuery(this).css({ "z-index": 10 }).siblings().css({ "z-index": 5 });
		});
	}
	function opeForm_ImageProcess() {
		if (jQuery(".ope-form-image-processor-wrapper").length <= 0) {
			const $ope_form_image_processor_panel =
				'\
		<div class="ope-form-image-processor-wrapper">\
		<div class="ope-form-image-processor">\
			<section id="dragAndDropSection">\
				<div class="drop" id="drop">\
					<span>' +
				ope_form_object.select_image_and_crop +
				'</span>\
				</div>\
				<input class="file-upload hidden" id="fileUpload" type="file">\
			</section>\
			<section class="hidden" id="resizeSection">\
				<div class="image-resize" id="resizeImage"></div>\
				<div class="control">\
					<button class="btn" id="crop">' +
				ope_form_object.image_crop_text +
				'</button>\
					<button class="btn" id="crop_cancel">' +
				ope_form_object.image_crop_text_cancel +
				'</button>\
				</div>\
			</section>\
			<div class="close-ope-form-processor-card"></div>\
		</div>\
	</div>';
			jQuery("body").append($ope_form_image_processor_panel);
		}
		jQuery(".ope-form-add-image").on("click", function () {
			jQuery("body").find(".ope-form-add-image").removeClass("current");
			jQuery(this).addClass("current");
			if (!jQuery("body").hasClass("show-ope-form-image-processor")) {
				jQuery("body").addClass("show-ope-form-image-processor");
			}
		});
		jQuery(".upload-image-content .btn-remove").on("click", function () {
			jQuery(this)
				.parent(".img-temp-content")
				.removeClass("has-image")
				.find("img")
				.attr("src", "");
			jQuery(this)
				.parents(".opeform-item")
				.find('input[type="ope_image"]')
				.val("");
			jQuery(".ope-form-image-processor #resizeImage").html("");
			verifyImage();
		});
		jQuery(".close-ope-form-processor-card").on("click", function () {
			if (jQuery("body").hasClass("show-ope-form-image-processor")) {
				jQuery("body").removeClass("show-ope-form-image-processor");
			}
			jQuery(".ope-form-image-processor #resizeSection").addClass("hidden");
			jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
				"hidden"
			);
		});
		jQuery(".ope-form-image-processor #drop").on("click", function () {
			jQuery(".ope-form-image-processor #fileUpload").trigger("click");
		});
		jQuery(".ope-form-image-processor #fileUpload").on("change", function (e) {
			addImage(e.target);
			e.target.value = "";
		});
		jQuery(".ope-form-image-processor #drop").on("dragover", function (e) {
			e.preventDefault();
			e.stopPropagation();
			jQuery(this).addClass("dragging");
		});
		jQuery(".ope-form-image-processor #drop").on("dragleave", function (e) {
			jQuery(this).removeClass("dragging");
		});
		jQuery(".ope-form-image-processor #drop").on("drop", function (e) {
			e.preventDefault();
			e.stopPropagation();
			var data = e.dataTransfer || e.originalEvent.dataTransfer;
			addImage(data);
		});
		function addImage(data) {
			jQuery(".ope-form-image-processor #dragAndDropSection").addClass(
				"hidden"
			);
			jQuery(".ope-form-image-processor").addClass("loading");
			let imgCondition = "max-width";
			var file = data.files[0];
			if (file.type.indexOf("image") === -1) {
				alert(ope_form_object.not_a_image);
				jQuery(".ope-form-image-processor").removeClass("loading");
				jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
					"hidden"
				);
				return false;
			}
			var reader = new FileReader();
			reader.onload = function (event) {
				var img = new Image();
				img.onload = function () {
					if (
						(img.height / img.width).toFixed(2) >=
						(
							jQuery(".ope-form-image-processor").height() /
							jQuery(".ope-form-image-processor").width()
						).toFixed(2)
					) {
						imgCondition = "max-height";
					} else {
						imgCondition = "max-width";
					}
					if (
						img.width < ope_form_object.crop_image_width ||
						img.height < ope_form_object.crop_image_height
					) {
						alert(ope_form_object.not_large_enough);
						jQuery(".ope-form-image-processor").removeClass("loading");
						jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
							"hidden"
						);
						return false;
					}
					if (
						img.width > ope_form_object.image_max_width ||
						img.height > ope_form_object.image_max_height
					) {
						alert(ope_form_object.too_large);
						jQuery(".ope-form-image-processor").removeClass("loading");
						jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
							"hidden"
						);
						return false;
					}
					cropImage(img, imgCondition);
				};
				img.src = event.target.result;
			};
			reader.readAsDataURL(file);
		}
		function cropImage(originalImage, imageCondition) {
			jQuery(originalImage)
				.attr("class", "ope-form-fullimage")
				.addClass(imageCondition);
			jQuery(".ope-form-image-processor #resizeImage").html(originalImage);
			jQuery(".ope-form-image-processor #resizeSection").removeClass("hidden");
			jQuery(".ope-form-image-processor").removeClass("loading");
			var newImage = new opeImageCrop(
				".ope-form-fullimage",
				ope_form_object.crop_image_width,
				ope_form_object.crop_image_height
			);
			jQuery(".ope-form-image-processor #crop")
				.off()
				.on("click", function () {
					var results = newImage.crop();
					jQuery(".ope-form-image-processor #resizeSection").addClass("hidden");
					jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
						"hidden"
					);
					jQuery(".ope-form-add-image.current")
						.parents(".opeform-item")
						.find(".img-temp-content")
						.addClass("has-image")
						.find("img")
						.attr("src", results.img.src);
					jQuery(".ope-form-add-image.current")
						.parents(".opeform-item")
						.find('input[type="ope_image"]')
						.val(results.img.src);
					jQuery("body").removeClass("show-ope-form-image-processor");
					verifyImage();
				});
			jQuery(".ope-form-image-processor #crop_cancel")
				.off()
				.on("click", function () {
					jQuery(".ope-form-image-processor #resizeSection").addClass("hidden");
					jQuery(".ope-form-image-processor #dragAndDropSection").removeClass(
						"hidden"
					);
				});
		}
	}
	jQuery(function () {
		if (jQuery(".ope-form").length > 0) {
			opeForm_ImageProcess();
			renewToken();
			jQuery('[name="ope_user_name"]').remove();
			bodyClassControl();
			capchacode();
			if (ope_form_object.check_immediately == 1) {
				verifyText();
				verifyImage();
				verifyEmail();
				verifyTel();
				verifyTextarea();
			}
			verifyCheckbox();
			radioBox();
			formSelect();
			opeFormConfirm();
			cloneForm();
			textRemaing();
			zIndexControl();
			verifyFile();
		}
	});
})(jQuery);
