<?php
/* Name:OPE FORM
 ** Version:20230419
 ** Author:1pxeye
 */
if (!defined('ABSPATH')) {
    die('Access Denied!');
}
require 'config.php';
if (defined('OPE_FORM_SESSION_LIFETIME')) {
    $session_timeout = OPE_FORM_SESSION_LIFETIME;
    //Set the maxlifetime of the session
    ini_set("session.gc_maxlifetime", $session_timeout);
    //Set the cookie lifetime of the session
    ini_set("session.cookie_lifetime", $session_timeout);
}
session_start([
    'cookie_lifetime' => OPE_FORM_SESSION_LIFETIME ? OPE_FORM_SESSION_LIFETIME : 1440,
    'gc_maxlifetime' => OPE_FORM_SESSION_LIFETIME ? OPE_FORM_SESSION_LIFETIME : 1440,
]);
function remove_post_type_from_wp_sitemap($post_types)
{
    unset($post_types['ope_form_box']);
    return $post_types;
}
add_filter('wp_sitemaps_post_types', 'remove_post_type_from_wp_sitemap', 10, 1);
function remove_taxonomies_from_wp_sitemap($tax)
{
    unset($tax['ope_form_box_category']);
    return $tax;
}
add_filter('wp_sitemaps_taxonomies', 'remove_taxonomies_from_wp_sitemap', 10, 1);
require 'config.php';
class opeFormClass
{
    public function max_file_upload_size()
    {
        $max_size = -1;
        $post_overhead = 1024; // POST data contains more than just the file upload; see comment from @jlh
        $files = array_merge(array(php_ini_loaded_file()), explode(",\n", php_ini_scanned_files()));
        foreach (array_filter($files) as $file) {
            $ini = parse_ini_file($file);
            $regex = '/^([0-9]+)([bkmgtpezy])$/i';
            if (!empty($ini['post_max_size']) && preg_match($regex, $ini['post_max_size'], $match)) {
                $post_max_size = round($match[1] * pow(1024, stripos('bkmgtpezy', strtolower($match[2]))));
                if ($post_max_size > 0) {
                    $max_size = $post_max_size - $post_overhead;
                }
            }
            if (!empty($ini['upload_max_filesize']) && preg_match($regex, $ini['upload_max_filesize'], $match)) {
                $upload_max_filesize = round($match[1] * pow(1024, stripos('bkmgtpezy', strtolower($match[2]))));
                if ($upload_max_filesize > 0 && ($max_size <= 0 || $max_size > $upload_max_filesize)) {
                    $max_size = $upload_max_filesize;
                }
            }
        }
        return $max_size;
    }
    public function convertToBytes(string $from): ?int
    {
        $units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB'];
        $number = substr($from, 0, -2);
        $suffix = strtoupper(substr($from, -2));
        //B or no suffix
        if (is_numeric(substr($suffix, 0, 1))) {
            return preg_replace('/[^\d]/', '', $from);
        }
        $exponent = array_flip($units)[$suffix] ?? null;
        if ($exponent === null) {
            return null;
        }
        return $number * (1024 ** $exponent);
    }
    public function getName($size)
    {
        $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
        $randomString = '';
        for ($i = 0; $i < $size; $i++) {
            $index = rand(0, strlen($characters) - 1);
            $randomString .= $characters[$index];
        }
        return $randomString;
    }
}
if (OPE_FORM_STORE_EMAIL_DATA == 1) {
    require 'post_type.php';
}
require 'opeform-ajax-common.php';
function ope_crypto_rand_secure($min, $max)
{
    $range = $max - $min;
    if ($range < 0) {
        return $min;
    }
    // not so random...
    $log = log($range, 2);
    $bytes = (int) ($log / 8) + 1; // length in bytes
    $bits = (int) $log + 1; // length in bits
    $filter = (int) (1 << $bits) - 1; // set all lower bits to 1
    do {
        $rnd = hexdec(bin2hex(openssl_random_pseudo_bytes($bytes)));
        $rnd = $rnd&$filter; // discard irrelevant bits
    } while ($rnd >= $range);
    return $min + $rnd;
}
function ope_getToken($length)
{
    $token = "";
    $codeAlphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    $codeAlphabet .= "abcdefghijklmnopqrstuvwxyz";
    $codeAlphabet .= "0123456789";
    for ($i = 0; $i < $length; $i++) {
        $token .= $codeAlphabet[ope_crypto_rand_secure(0, strlen($codeAlphabet))];
    }
    return $token;
}
function opeform_function($atts)
{
    ob_start();
    wp_enqueue_script('ope-form-module');
    wp_enqueue_style('ope-form-main');
    wp_enqueue_script('ope-form-script');
    ?>
<input type="hidden" required name="ope_user_name">
<?php
// image
    if (@$atts['use'] == "image") {
        ?><div class="opeform-item">
    <label class="upload-image-content"><input type="ope_image" data-item-name="<?php echo @$atts['title']; ?>"
            data-id="<?php echo @$atts['name']; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?><?php echo @$atts['required'] == "true" ? "required" : ""; ?>>
        <div class="img-temp-content">
            <img src="data:image/gif;base64,R0lGODlhAQABAIAAAAAAAP///yH5BAEAAAAALAAAAAABAAEAAAIBRAA7" alt="">
            <span class="btn-remove"></span>
        </div>
        <div class="btn-add-image"><span class="ope-form-add-image"><?php echo OPE_FORM_IMAGE_UPLOAD_BTN_TEXT; ?></span>
        </div>
    </label>
</div>
<?php
}
// file
    if (@$atts['use'] == "file") {
        $opeFormClass = new opeFormClass();
        $max_upload_size = $opeFormClass->max_file_upload_size();
        $ope_form_max_upload_size = str_replace('MB', '', OPE_FORM_MAX_UPLOAD_SIZE);
        $ope_form_max_upload_size = str_replace('Mb', '', $ope_form_max_upload_size);
        $ope_form_max_upload_size = str_replace('mb', '', $ope_form_max_upload_size);
        $ope_form_max_upload_size = str_replace('M', '', $ope_form_max_upload_size);
        $ope_form_max_upload_size = str_replace('m', '', $ope_form_max_upload_size);
        $ope_form_user_set_upload_size = $opeFormClass->convertToBytes($ope_form_max_upload_size . 'MB');
        $max_upload_size = min($max_upload_size, $ope_form_user_set_upload_size);
        if (@$atts['size']) {
            $size = $opeFormClass->convertToBytes($atts['size']);
            $size = min($max_upload_size, $size);
        } else {
            $size = $max_upload_size;
        }
        ?><div class="opeform-item"><label class="file-label"><input type="<?php echo @$atts['use']; ?>"
            data-item-name="<?php echo @$atts['title']; ?>" size="<?php echo $size; ?>"
            data-id="<?php echo @$atts['name']; ?>" <?php
if (@$atts['accept']) {
            ?> accept="<?php echo @$atts['accept']; ?>" <?php
}
        ?> <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?><?php echo @$atts['required'] == "true" ? "required" : ""; ?>>
        <div class="btn-upload">
            <span><?php echo OPE_FORM_FILE_UPLOAD_BTN_TEXT . '<small>(<' . round($size / 1024 / 1024, 2) . 'MB)</small>' ?></span>
        </div>
    </label>
    <div class="upload-file-status">
        <div class="upload-file-name"></div>
        <div class="remove-file"></div>
    </div>
</div>
<?php
}
// input
    if (@$atts['use'] == "text" || @$atts['use'] == "email" || @$atts['use'] == "tel") {
        ?><div class="opeform-item"><input type="<?php echo @$atts['use']; ?>"
        data-item-name="<?php echo @$atts['title']; ?>" data-id="<?php echo @$atts['name']; ?>"
        placeholder="<?php echo @$atts['placeholder']; ?>" maxlength="<?php echo @$atts['length']; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?><?php echo @$atts['required'] == "true" ? "required" : ""; ?>
        <?php echo @$atts['confirm'] == "true" ? "confirm" : ""; ?>
        <?php echo @$atts['from_name'] == "true" ? "data-from-name" : ""; ?>
        <?php echo @$atts['from_email'] == "true" ? "data-from-email" : ""; ?>></div><?php
}
    if (@$atts['use'] == "number") {
        ?><div class="opeform-item"><input type="<?php echo @$atts['use']; ?>"
        data-item-name="<?php echo @$atts['title']; ?>" data-id="<?php echo @$atts['name']; ?>"
        placeholder="<?php echo @$atts['placeholder']; ?>" maxlength="<?php echo @$atts['length']; ?>"
        min="<?php echo @$atts['min']; ?>" max="<?php echo @$atts['max']; ?>" step="<?php echo @$atts['step']; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?><?php echo @$atts['required'] == "true" ? "required" : ""; ?>
        <?php echo @$atts['confirm'] == "true" ? "confirm" : ""; ?>
        <?php echo @$atts['from_name'] == "true" ? "data-from-name" : ""; ?>
        <?php echo @$atts['from_email'] == "true" ? "data-from-email" : ""; ?>></div><?php
}
    // textarea
    if (@$atts['use'] == "textarea") {
        ?><div class="opeform-item">
    <textarea data-item-name="<?php echo @$atts['title']; ?>" data-id="<?php echo @$atts['name']; ?>"
        placeholder="<?php echo @$atts['placeholder']; ?>" maxlength="<?php echo @$atts['length']; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?> <?php echo @$atts['required'] == "true" ? "required" : ""; ?>></textarea>
    <?php if (@$atts['length']) {
            ?>
    <div class="text-remaining"><span class="r">0</span>/<span class="total"></span></div>
    <?php
}?>
</div>
<?php
}
    // checkbox
    if (@$atts['use'] == "checkbox") {
        ?><div class="opeform-item has-checkbox"
    data-quantity="<?php echo @$atts['quantity'] ? @$atts['quantity'] : 100; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?> <?php echo @$atts['required'] == "true" ? "required" : ""; ?>>
    <?php
if (@$atts['option']) {
            $arr = explode(",", $atts['option']);
            foreach ($arr as $a) {
                ?>
    <label><input type="checkbox" data-item-name="<?php echo @$atts['title']; ?>"
            data-id="<?php echo @$atts['name']; ?>" value="<?php echo $a; ?>"><i
            class="icon"></i><span><?php echo $a; ?></span></label>
    <?php
}
        }
        ?>
</div>
<?php
}
// radio
    if (@$atts['use'] == "radio") {
        ?><div class="opeform-item has-radiobox" <?php echo @$atts['required'] == "true" ? "required" : ""; ?>>
    <?php
if (@$atts['option']) {
            $arr = explode(",", $atts['option']);
            $radio_i = 1;
            foreach ($arr as $a) {
                ?>
    <label><input type="radio" <?php
if (@$atts['class']) {
                    echo 'class="' . $atts['class'] . '" ';
                }?><?php if ($radio_i == 1) {echo 'checked="checked"';}?>
            data-item-name="<?php echo @$atts['title']; ?>" data-id="<?php echo @$atts['name']; ?>"
            value="<?php echo $a; ?>"><i class="icon"></i><span><?php echo $a; ?></span></label>
    <?php
$radio_i++;
            }
        }
        ?>
</div>
<?php
}
// select
    if (@$atts['use'] == "select") {
        ?><div class="opeform-item has-select" <?php echo @$atts['required'] == "true" ? "required" : ""; ?>>
    <div class="select">
        <div class="selected-text"></div>
        <input type="hidden" data-item-name="<?php echo @$atts['title']; ?>" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?> data-id="<?php echo @$atts['name']; ?>">
        <div class="select-wrapper">
            <?php
if (@$atts['required'] != "true") {
            ?>
            <div data-value="">-</div>
            <?php
}
        if (isset($atts['option'])) {
            if (!@$atts['dynamic-number-range']) {
                $arr = explode(",", $atts['option']);
                foreach ($arr as $a) {
                    ?>
            <div data-value="<?php echo $a; ?>"><?php echo $a; ?></div>
            <?php
}
            } else {
                $range = $atts['dynamic-number-range'];
                if (!empty($range)) {
                    $range = preg_replace('/\s+/', '', $range);
                    $start_num = explode('~', $range)[0];
                    $end_num = explode('~', $range)[1];
                    if (!empty($start_num)) {
                        if (strpos($start_num, 'nowYear') !== false) {
                            if (strpos($start_num, '-') !== false) {
                                $left = explode('-', $start_num)[0];
                                $right = explode('-', $start_num)[1];
                                if ($left == 'nowYear') {
                                    $start_num = (int) date('Y') - (int) $right;
                                } else {
                                    $start_num = (int) $left - (int) date('Y');
                                }
                            } else if (strpos($start_num, '+') !== false) {
                                $left = explode('+', $start_num)[0];
                                $right = explode('+', $start_num)[1];
                                if ($left == 'nowYear') {
                                    $start_num = (int) date('Y') + (int) $right;
                                } else {
                                    $start_num = (int) $left + (int) date('Y');
                                }
                            } else {
                                $start_num = (int) date('Y');
                            }
                        }
                    }
                    if (!empty($end_num)) {
                        if (strpos($end_num, 'nowYear') !== false) {
                            if (strpos($end_num, '-') !== false) {
                                $left = explode('-', $end_num)[0];
                                $right = explode('-', $end_num)[1];
                                if ($left == 'nowYear') {
                                    $end_num = (int) date('Y') - (int) $right;
                                } else {
                                    $end_num = (int) $left - (int) date('Y');
                                }
                            } else if (strpos($end_num, '+') !== false) {
                                $left = explode('+', $end_num)[0];
                                $right = explode('+', $end_num)[1];
                                if ($left == 'nowYear') {
                                    $end_num = (int) date('Y') + (int) $right;
                                } else {
                                    $end_num = (int) $left + (int) date('Y');
                                }
                            } else {
                                $end_num = (int) date('Y');
                            }
                        }
                    }
                    if ($start_num <= $end_num) {
                        for ($i = (int) $start_num; $i <= (int) $end_num; $i++) {
                            ?>
            <div data-value="<?php echo $i; ?>"><?php echo $i; ?></div>
            <?php
}
                    } else {
                        for ($i = (int) $start_num; $i >= (int) $end_num; $i--) {
                            ?>
            <div data-value="<?php echo $i; ?>"><?php echo $i; ?></div>
            <?php
}
                    }
                    if (empty($start_num) && empty($end_num)) {
                        if (strpos($range, 'nowYear') !== false) {
                            ?>
            <div data-value="<?php echo (int) date('Y'); ?>"><?php echo (int) date('Y'); ?></div>
            <?php
} else {
                            ?>
            <div data-value="<?php echo $range; ?>"><?php echo $range; ?></div>
            <?php
}
                    }
                }
            }
        }
        ?>
        </div>
    </div>
</div>
<?php
}
    // submit
    if (@$atts['use'] == "submit") {
        ?><div class="opeform-item">
    <div class="opeform-submit" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?> data-action="<?php echo @$atts['action'] == true ? @$atts['action'] : ""; ?>">
        <span><?php echo OPE_FORM_NEXT_BTN ? OPE_FORM_NEXT_BTN : "Next"; ?></span>
    </div>
    <input type="hidden" name="ope_form_token" value="">
</div>
<?php
}
    // verification
    if (@$atts['use'] == "verification") {
        $unique_id = uniqid();
        ?><div class="opeform-item">
    <div class="opeform-verification">
        <input type="text" <?php
if (@$atts['class']) {
            echo 'class="' . $atts['class'] . '" ';
        }?> required maxlength="8" data-id="<?php echo $unique_id; ?>">
        <div class="opeform-verification-wrapper">
            <div class="verification-graph" data-string="<?php echo $unique_id; ?>"></div>
            <i><em><?php echo @$atts['notice']; ?></em></i>
        </div>
    </div>
</div>
<?php
}
    return ob_get_clean();
}
add_action('init', function () {
    add_shortcode('opeform', 'opeform_function');
});
function ope_form_enqueue()
{
    wp_register_script('ope-form-module', get_template_directory_uri() . '/pack/contact-form/assets/js/module.js', array(), crc32(date("YmdH")), true);
    wp_register_style('ope-form-main', get_template_directory_uri() . '/pack/contact-form/assets/css/style.css', array(), crc32(date("YmdH")), 'all');
    if (OPE_FORM_AUTOFILLADDRESS_JP == 1) {
        wp_enqueue_script('ope-form-autofill-zipcode-jp', 'https://yubinbango.github.io/yubinbango/yubinbango.js', array(), crc32(date("YmdH")), true);
    }
    wp_register_script('ope-form-script', get_template_directory_uri() . '/pack/contact-form/assets/js/script.js', array(),
        crc32(date("YmdH")), true);
    wp_localize_script('ope-form-script', 'ope_form_object', array(
        'ajaxurl' => admin_url('admin-ajax.php'),
        'form_nonce' => wp_create_nonce('ope_form_nonce'),
        'prev_btn_text' => OPE_FORM_PREV_BTN,
        'send_btn_text' => OPE_FORM_SEND_BTN,
        'invalid_email' => OPE_FORM_INVALID_EMAIL_ADDRESS_FORMAT,
        'invalid_phone' => OPE_FORM_INVALID_PHONE_NUMBER_FORMAT,
        'email_not_matched' => OPE_FORM_EMAIL_NOT_MATCHED,
        'required' => OPE_FORM_REQUIRED,
        'error' => OPE_FORM_ERROR,
        'verification_failed' => OPE_FORM_VERIFICATION_FAILED,
        'return_btn_text' => OPE_FORM_RETURN_BTN_TEXT,
        'check_immediately' => OPE_FORM_CHECK_IMMEDIATELY,
        'auto_return' => OPE_FORM_AUTO_RETURN,
        'auto_return_timeleft' => OPE_FORM_AUTO_RETURN_TIMELEFT,
        'send_failed' => OPE_FORM_SEND_FAILED,
        'name_format' => OPE_FORM_NAME_FORMAT,
        'fileTooBig' => OPE_FORM_FILE_TOO_BIG,
        'fileTypeError' => OPE_FORM_FILE_TYPE_ERROR,
        'auth_error' => OPE_FORM_AUTH_ERROR,
        'invalid_string' => OPE_FORM_INVALID_STRING,
        'select_image_and_crop' => OPE_FORM_SELECT_IMAGE_AND_CROP,
        'image_crop_text' => OPE_FORM_IMAGE_CROP_TEXT,
        'image_crop_text_cancel' => OPE_FORM_IMAGE_CROP_TEXT_CANCEL,
        'crop_image_width' => OPE_FORM_IMAGE_CROP_WIDTH,
        'crop_image_height' => OPE_FORM_IMAGE_CROP_HEIGHT,
        'not_a_image' => OPE_FORM_NOT_A_IMAGE,
        'not_large_enough' => OPE_FORM_IMAGE_NOT_LARGE_ENOUGH . PHP_EOL . OPE_FORM_IMAGE_CROP_MAX_WIDTH . 'px>=W>=' . OPE_FORM_IMAGE_CROP_WIDTH . 'px' . PHP_EOL . OPE_FORM_IMAGE_CROP_MAX_HEIGHT . 'px>=H>=' . OPE_FORM_IMAGE_CROP_HEIGHT . "px",
        'image_max_width' => OPE_FORM_IMAGE_CROP_MAX_WIDTH,
        'image_max_height' => OPE_FORM_IMAGE_CROP_MAX_HEIGHT,
        'too_large' => OPE_FORM_IMAGE_TOO_LARGE . PHP_EOL . OPE_FORM_IMAGE_CROP_MAX_WIDTH . 'px>=W>=' . OPE_FORM_IMAGE_CROP_WIDTH . 'px' . PHP_EOL . OPE_FORM_IMAGE_CROP_MAX_HEIGHT . 'px>=H>=' . OPE_FORM_IMAGE_CROP_HEIGHT . "px",
    ));
}
add_action('wp_enqueue_scripts', 'ope_form_enqueue');
function disable_new_posts()
{
// Hide sidebar link
    global $submenu;
    unset($submenu['edit.php?post_type=ope_form_box'][10]);
// Hide link on listing page
    if (isset($_GET['post_type']) && $_GET['post_type'] == 'ope_form_box') {
        echo '<style type="text/css">
#favorite-actions,
.add-new-h2,
.wrap .wp-heading-inline+.page-title-action {
    display: none;
}
</style>';
    }
}
function ope_form_enqueue_admin()
{
    wp_enqueue_style('ope-form-main-admin', get_template_directory_uri() . '/pack/contact-form/assets/css/admin-style.css',
        array(), crc32(date("YmdH")), 'all');
    wp_enqueue_script('ope-form-script-admin', get_template_directory_uri() .
        '/pack/contact-form/assets/js/script-admin.js', array(), crc32(date("YmdH")), true);
    wp_localize_script('ope-form-script-admin', 'ope_form_object_admin', array(
        'ajaxurl' => admin_url('admin-ajax.php'),
        'form_nonce_admin' => wp_create_nonce('ope_form_nonce_admin'),
    ));
}
if (OPE_FORM_STORE_EMAIL_DATA == 1) {
    add_action('admin_enqueue_scripts', 'ope_form_enqueue_admin');
    add_action('admin_menu', 'disable_new_posts');
}