<?php
if (!defined('ABSPATH')) {
    die('Access Denied!');
}
$token = @$_POST['token'];
$error_callBack["to"] = array("status" => "failed");
$error_callBack["reply"] = array("status" => "failed");
session_start([
    'cookie_lifetime' => OPE_FORM_SESSION_LIFETIME ? OPE_FORM_SESSION_LIFETIME : 1440,
    'read_and_close' => true,
]);
if (!(isset($token) && $token == $_SESSION["ope_form_token"])) {
    $error_callBack["to"] = array("status" => "failed", "code" => "Authentication Failed - Token Error");
    echo json_encode($error_callBack);
    die();
}
if (!(isset($_POST['nonce']) && wp_verify_nonce($_POST['nonce'], 'ope_form_nonce'))) {
    $error_callBack["to"] = array("status" => "failed", "code" => "Authentication Failed - Nonce Error");
    echo json_encode($error_callBack);
    die();
}
if ($_POST['name'] !== '-/-') {
    $error_callBack["to"] = array("status" => "failed", "code" => "Authentication Failed - Trap Error");
    echo json_encode($error_callBack);
    die();
}
if (defined('OPE_FORM_USE_CAPCHACODE') && OPE_FORM_USE_CAPCHACODE == 1) {
    $unique_id = $_POST['id'];
    $value = $_POST['value'];
    if (!isset($_SESSION["captcha_code_" . $unique_id])) {
        $error_callBack["to"] = array("status" => "failed", "code" => "Authentication Failed - Captcha Error 1");
        echo json_encode($error_callBack);
        die();
    }
    if ($value != $_SESSION["captcha_code_" . $unique_id]) {
        $error_callBack["to"] = array("status" => "failed", "code" => "Authentication Failed - Captcha Error 2");
        echo json_encode($error_callBack);
        die();
    }
}
$messages = @$_POST['data'];
$messages = json_decode(stripslashes($messages));
$fileNames = @$_POST['fileNames'];
$fileNames = json_decode(stripslashes($fileNames));
$client_email = htmlspecialchars(@$_POST['from_email']);
$client_email = $client_email ? $client_email : '(undefined email)';
$client_name = htmlspecialchars(@$_POST['from_name']);
$client_name = $client_name ? $client_name : "(undefined user)";
$category = htmlspecialchars(@$_POST['cat']);
$host = $_SERVER['HTTP_HOST'];
$user_agent = $_SERVER['HTTP_USER_AGENT'];
$ip = !empty($_SERVER['HTTP_CLIENT_IP']) ? $_SERVER['HTTP_CLIENT_IP'] : (!empty($_SERVER['HTTP_X_FORWARDED_FOR']) ? explode(",", $_SERVER['HTTP_X_FORWARDED_FOR'])[0] : $_SERVER['REMOTE_ADDR']);
$uri = $_SERVER['REQUEST_URI'];
$behavior = $_POST['behavior'];
$behavior = json_decode(stripslashes($behavior));
function getOS()
{
    $user_agent = $_SERVER['HTTP_USER_AGENT'];
    $os_platform = "Unknown System";
    $os_array = array(
        '/windows nt 10/i' => 'Windows 10/11',
        '/windows nt 6.3/i' => 'Windows 8.1',
        '/windows nt 6.2/i' => 'Windows 8',
        '/windows nt 6.1/i' => 'Windows 7',
        '/windows nt 6.0/i' => 'Windows Vista',
        '/windows nt 5.2/i' => 'Windows Server 2003/XP x64',
        '/windows nt 5.1/i' => 'Windows XP',
        '/windows xp/i' => 'Windows XP',
        '/windows nt 5.0/i' => 'Windows 2000',
        '/windows me/i' => 'Windows ME',
        '/win98/i' => 'Windows 98',
        '/win95/i' => 'Windows 95',
        '/win16/i' => 'Windows 3.11',
        '/macintosh|mac os x/i' => 'Mac OS X',
        '/mac_powerpc/i' => 'Mac OS 9',
        '/linux/i' => 'Linux',
        '/ubuntu/i' => 'Ubuntu',
        '/iphone/i' => 'iPhone',
        '/ipod/i' => 'iPod',
        '/ipad/i' => 'iPad',
        '/android/i' => 'Android',
        '/blackberry/i' => 'BlackBerry',
        '/webos/i' => 'Mobile',
    );
    foreach ($os_array as $regex => $value) {
        if (preg_match($regex, $user_agent)) {
            $os_platform = $value;
        }
    }
    return $os_platform;
}
if (OPE_FORM_STORE_EMAIL_DATA == 1) {
    $term = term_exists($category, 'ope_form_box_category');
    if ($term !== 0 && $term !== null) {
        $term_data = $term;
    } else {
        $term_data = wp_insert_term(
            $category,
            'ope_form_box_category'
        );
    }
    unset($term);
    $term_id = $term_data['term_id'];
    $taxonomy = 'ope_form_box_category';
    date_default_timezone_set(OPE_FORM_TIMEZONE);
    $title = mb_substr($client_name, 0, 1, 'utf-8') . '-' . date('Y-m-d H:i:s');
    $attachment_files = array();
    $attachment_images = array();
    if (OPE_FORM_SAVE_ATTACHMENT_FILE_IN_SERVER == 1) {
        $year = date("Y");
        $month = date("m");
        if (!is_dir(ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month)) {
            mkdir(ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME, 0755);
            mkdir(ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year, 0755);
            mkdir(ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month, 0755);
        }
        if (!is_dir(ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month)) {
            return;
        }
        $ope_form_class = new opeFormClass();
        if ($_FILES) {
            foreach ($fileNames as $fn) {
                $unique_name = $ope_form_class->getName(15);
                $info = pathinfo($_FILES[$fn]['name']);
                $ext = $info['extension'];
                $newname = date("Y-m-d-H-i-s") . '-' . $unique_name . '.' . $ext;
                $target = ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname;
                copy($_FILES[$fn]['tmp_name'], $target);
                array_push($attachment_files, array(
                    'name' => $fn,
                    'url' => "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname,
                ));
            }
        }
        foreach ($messages as $msg) {
            $unique_name = $ope_form_class->getName(15);
            $newname = date("Y-m-d-H-i-s") . '-' . $unique_name . '.jpg';
            preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
            if (!empty(@$img_tag)) {
                preg_match('/src="([^"]*)"/', $img_tag[0], $imgsrc);
                $base64string = '';
                $target = ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname;
                if (!empty(@$imgsrc)) {
                    if (!empty(@$imgsrc[1])) {
                        $parts = explode(";base64,", $imgsrc[1]);
                        $imagebase64 = base64_decode($parts[1]);
                        array_push($attachment_images, array(
                            'name' => $msg->key,
                            'url' => "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname,
                        ));
                        file_put_contents($target, $imagebase64);
                    }
                }
            }
        }
    }
    $ope_form_post = array(
        'post_title' => $title,
        'post_content' => '',
        'post_status' => 'publish',
        'post_author' => 1,
        'post_type' => 'ope_form_box',
        'tax_input' => array(
            "video_category" => $taxonomy,
        ),
        'meta_input' => array(
            'user_email_data' => $messages,
            'user_http_data' => array(
                'ip' => $ip,
                'host' => $host,
                'uri' => $uri,
                'user_os' => getOS(),
                'user_agent' => $user_agent,
                'client_click_action' => $behavior->click_action,
                'client_multistep_count' => $behavior->multistep_count,
                'client_UA' => $behavior->ua,
                'client_request_code' => $behavior->request_code,
                'request_code_REAL' => $_SESSION["captcha_code_" . $unique_id],
                'current_page' => $behavior->current_page,
                'client_language' => $behavior->language,
                'client_logical_processors' => $behavior->logical_processors,
                'client_screen_size' => $behavior->screen_size,
                'client_click_position' => $behavior->click_position,
            ),
            'user_attachment_images' => $attachment_images,
            'user_attachment_files' => $attachment_files,
        ),
    );
    $post_id = wp_insert_post($ope_form_post);
    wp_set_object_terms($post_id, intval($term_id), $taxonomy);
}
if (OPE_FORM_HTML_MAIL !== 1) {
    $content = '';
    $content .= '';
    foreach ($messages as $msg) {
        $title = htmlspecialchars($msg->key);
        $value = htmlspecialchars($msg->value);
        preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
        if (!empty(@$img_tag)) {
            continue;
        }
        $content .= $title . '：' . $value . PHP_EOL;
    }
    $content .= PHP_EOL;
    $content .= '----------For Debug-------------' . PHP_EOL;
    $content .= 'IP: ' . $ip . PHP_EOL;
    $content .= 'User Agent: ' . $user_agent . PHP_EOL;
    $content .= 'User OS: ' . getOS() . PHP_EOL;
    $content .= 'URI: ' . $uri . PHP_EOL;
    $content .= 'Host: ' . $host . PHP_EOL;
    if (!empty(OPE_FORM_EMAIL_REPLY_BODY_ABOVE)) {
        $reply_content = OPE_FORM_EMAIL_REPLY_BODY_ABOVE . PHP_EOL . PHP_EOL;
    } else {
        $reply_content = '';
    }
    foreach ($messages as $msg) {
        $title = htmlspecialchars($msg->key);
        $value = htmlspecialchars($msg->value);
        preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
        if (!empty(@$img_tag)) {
            continue;
        }
        $reply_content .= $title . '：' . $value . PHP_EOL;}
    if (!empty(OPE_FORM_EMAIL_REPLY_BODY_BELOW)) {
        $reply_content .= PHP_EOL . PHP_EOL;
        $reply_content .= OPE_FORM_EMAIL_REPLY_BODY_BELOW . PHP_EOL;
    }
} else {
    $content = '';
    $content .= '<table style="border:1px solid #ccc;border-collapse:collapse;font-size:14px;font-family: " sans-serif;">';
    foreach ($messages as $msg) {
        $title = htmlspecialchars($msg->key);
        $value = htmlspecialchars($msg->value);
        preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
        if (!empty(@$img_tag)) {
            continue;
        }
        $value = preg_replace('/\r|\n/', '<br>', trim($value));
        $content .= '<tr style="border:1px solid #ccc;">
        <th
            style="border:1px solid #ccc;background-color:#eeeeee;font-weight:bold;min-width:100px;padding:5px 10px;white-space:nowrap;">
            ' . $title . '</th>
        <td style="border:1px solid #ccc;background-color:#f3f3f3;font-weight:normal;padding:5px 10px;">' . $value . '
        </td>
    </tr>';}
    $content .= '</table>';
    $content .= '<p style="font-size:12px;color:#666;">';
    $content .= 'IP: ' . $ip . '<br>';
    $content .= 'User Agent: ' . $user_agent . '<br>';
    $content .= 'User OS: ' . getOS() . '<br>';
    $content .= 'URI: ' . $uri . '<br>';
    $content .= 'Host: ' . $host;
    $content .= '</p>';
    if (!empty(OPE_FORM_EMAIL_REPLY_BODY_ABOVE)) {
        $reply_content = '<p>' . OPE_FORM_EMAIL_REPLY_BODY_ABOVE . '</p>';
    } else {
        $reply_content = '';
    }
    $reply_content .= '<table style="border:1px solid #ccc;border-collapse:collapse;font-size:14px;font-family: " Verdana,
    Geneva, Tahoma, sans-serif;">';
    foreach ($messages as $msg) {
        $title = htmlspecialchars($msg->key);
        $value = htmlspecialchars($msg->value);
        preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
        if (!empty(@$img_tag)) {
            continue;
        }
        $value = preg_replace('/\r|\n/', '<br>', trim($value));
        $reply_content .= '<tr style="border:1px solid #ccc;">
        <th
            style="border:1px solid #ccc;background-color:#eeeeee;min-width:100px;font-weight:bold;padding:5px 10px;white-space:nowrap;">
            ' . $title . '</th>
        <td style="border:1px solid #ccc;background-color:#f3f3f3;font-weight:normal;padding:5px 10px;">' . $value . '
        </td>
    </tr>';}
    $reply_content .= '</table>';
    if (!empty(OPE_FORM_EMAIL_REPLY_BODY_BELOW)) {
        $reply_content .= '<p>' . OPE_FORM_EMAIL_REPLY_BODY_BELOW . '</p>';
    }
}
