<?php
use PHPMailer\PHPMailer\PHPMailer;
if (!defined('ABSPATH')) {
    die('Access Denied!');
}
if (defined('OPE_FORM_USE_CAPCHACODE') && OPE_FORM_USE_CAPCHACODE == 1) {
    add_action('wp_ajax_get_CAPCHACODE', 'get_CAPCHACODE');
    add_action('wp_ajax_nopriv_get_CAPCHACODE', 'get_CAPCHACODE');
}
function get_CAPCHACODE()
{
    if (!(isset($_POST['security']) && wp_verify_nonce($_POST['security'], 'ope_form_nonce'))) {
        die();
    }
    $unique_id = $_POST['id'];
    $width = 200;
    $height = 80;
    $noise_level = 45;
    $random_num = md5(random_bytes(64));
    $captcha_code = substr($random_num, 0, 8);
    foreach ($_SESSION as $key => $value) {
        if (strpos($key, 'captcha_code_') === 0) {
            unset($_SESSION[$key]);
        }
    }
    $_SESSION["captcha_code_" . $unique_id] = $captcha_code;
    session_write_close();
    $im = imagecreatetruecolor($width, $height);
    $bg = imagecolorallocate($im, rand(50, 60), rand(70, 90), rand(100, 120)); //background color
    $fg = imagecolorallocate($im, rand(200, 200), rand(200, 200), rand(200, 200)); //text color
    $ns = imagecolorallocate($im, rand(110, 140), rand(140, 160), rand(150, 170)); //noise color
    imagefill($im, 0, 0, $bg);
    $font = get_template_directory() . '/pack/contact-form/assets/fonts/capchafont.ttf';
    imagettftext($im, 30, 10, 10, 60, $fg, $font, $captcha_code);
    for ($i = 0; $i < $noise_level; $i++) {
        for ($j = 0; $j < $noise_level; $j++) {
            imagesetpixel(
                $im,
                rand(0, $width),
                rand(0, $height),
                $ns
            );
        }
    }
    for ($i = 0; $i < 9; $i++) {
        imagearc($im, mt_rand(-$width, $width), mt_rand(-$height, $height), mt_rand(30, $width * 2), mt_rand(20, $height * 2), mt_rand(0, 360), mt_rand(0, 360), $fg);
    }
    header("Cache-Control: no-cache, must-revalidate");
    header('Content-type: image/png');
    ob_start();
    imagepng($im);
    $imagedata = ob_get_contents();
    ob_end_clean();
    echo base64_encode($imagedata);
    imagedestroy($im);
    die();
}
if (defined('OPE_FORM_USE_CAPCHACODE') && OPE_FORM_USE_CAPCHACODE == 1) {
    add_action('wp_ajax_check_CAPCHACODE', 'check_CAPCHACODE');
    add_action('wp_ajax_nopriv_check_CAPCHACODE', 'check_CAPCHACODE');
}
function check_CAPCHACODE()
{
    if (!(isset($_POST['security']) && wp_verify_nonce($_POST['security'], 'ope_form_nonce'))) {
        die("Access Denied!");
    }
    $unique_id = $_POST['id'];
    $value = $_POST['value'];
    if ($value == $_SESSION["captcha_code_" . $unique_id]) {
        echo json_encode(array("match" => 1));
    } else {
        echo json_encode(array("match" => 0));
    }
    die();
}
add_action('wp_ajax_export_email_data_to_csv', 'export_email_data_to_csv');
function export_email_data_to_csv()
{
    if (!(isset($_POST['security']) && wp_verify_nonce($_POST['security'], 'ope_form_nonce_admin'))) {
        die("Access Denied!");
    }
    $id = $_POST['pid'];
    $user_email_data = get_post_meta($id, 'user_email_data', true);
    if (count($user_email_data) == 0) {
        return null;
    }
    ?>
<table><?php
foreach ($user_email_data as $ued) {
        ?><tr>
        <td class="head"><?php echo $ued->key; ?></td>
        <td><?php echo esc_html($ued->value); ?></td>
    </tr><?php
}
    ?>
</table>
<?php
die();
}
if (OPE_FORM_USE_WP_MAIL == 0) {
    require 'opeform-ajax-phpmailer.php';
} else if (OPE_FORM_USE_WP_MAIL == 1 && OPE_FORM_SMTP == 1) {
    require 'opeform-ajax-wp-mail.php';
}
add_action('wp_ajax_renewToken', 'renewTokenFuntion');
add_action('wp_ajax_nopriv_renewToken', 'renewTokenFuntion');
function renewTokenFuntion()
{
    if (!(isset($_POST['s']) && wp_verify_nonce($_POST['s'], 'ope_form_nonce'))) {
        die("Access Denied!");
    }
    if (!isset($_SESSION["ope_form_token"])) {
        $ope_form_token = ope_getToken(64);
        $_SESSION["ope_form_token"] = $ope_form_token;
        session_write_close();
    }
    echo json_encode(array("token" => $_SESSION["ope_form_token"]));
    die();
}