<?php
use PHPMailer\PHPMailer\Exception;
use PHPMailer\PHPMailer\PHPMailer;
if (!defined('ABSPATH')) {
    die('Access Denied!');
}
add_action('wp_ajax_send_email', 'send_email');
add_action('wp_ajax_nopriv_send_email', 'send_email');
function send_email()
{
    require 'ope-form-data.php';
    require 'phpmailer/src/Exception.php';
    require 'phpmailer/src/PHPMailer.php';
    if (OPE_FORM_SMTP != 0) {
        require 'phpmailer/src/SMTP.php';
    }
    $callBack = array();
    $mail = new PHPMailer(true);
    if (strpos($content, '0x0A') !== false || strpos($content, '0x0D') !== false) {
        $callBack["to"] = array("status" => "failed", "code" => "Invalid String");
        $callBack["reply"] = array("status" => "failed", "code" => "Invalid String");
        echo json_encode($callBack);
        die();
    }
    try {
        $mail->CharSet = 'UTF-8';
        //Server settings
        //$mail->SMTPDebug = SMTP::DEBUG_SERVER; //Enable verbose debug output
        if (OPE_FORM_SMTP == 1) {
            $mail->isSMTP(); //Send using SMTP
            $mail->Host = OPE_FORM_SMTP_HOST; //Set the SMTP server to send through
            $mail->SMTPAuth = true; //Enable SMTP authentication
            $mail->Username = OPE_FORM_SMTP_USER_NAME; //SMTP username
            $mail->Password = OPE_FORM_SMTP_PASSWORD; //SMTP password
            if (OPE_FORM_SMTP_SECURE == 1) {
                $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS; //Enable implicit TLS encryption
            } else if (OPE_FORM_SMTP_SECURE == 2) {
                $mail->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS; //Enable implicit TLS encryption
            }
            $mail->Port = OPE_FORM_SMTP_PORT; //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
        }
        $receiver = OPE_FORM_EMAIL_RECEIVER_ADDRESS;
        if (OPE_FORM_SMTP == 1) {
            $MAIL_FROM_ADDRESS = OPE_FORM_SMTP_USER_NAME;
        } else {
            $MAIL_FROM_ADDRESS = OPE_FORM_EMAIL_FROM_ADDRESS;
        }
        $MAIL_FROM_NAME = OPE_FORM_EMAIL_FROM_NAME;
        $mail->setFrom($MAIL_FROM_ADDRESS, $MAIL_FROM_NAME);
        foreach ($receiver as $r) {
            $mail->addAddress($r);
        }
        if (OPE_FORM_HTML_MAIL == 1) {
            $mail->isHTML(true);
        } else {
            $mail->isHTML(false);
        }
        $mail->Subject = OPE_FORM_EMAIL_ADMIN_SUBJECT . '-' . date('Y-m-d H:i:s');
        $mail->Body = $content;
        if ($_FILES) {
            foreach ($fileNames as $fn) {
                $mail->AddAttachment($_FILES[$fn]['tmp_name'], $_FILES[$fn]['name']);
            }
        }
        $temp_images = array();
        foreach ($messages as $msg) {
            $unique_name = $ope_form_class->getName(15);
            $newname = $msg->key . '-' . date("Y-m-d-H-i-s") . '-' . $unique_name . '.jpeg';
            preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
            if (!empty(@$img_tag)) {
                preg_match('/src="([^"]*)"/', $img_tag[0], $imgsrc);
                $base64string = '';
                $target = ABSPATH . "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname;
                if (!empty(@$imgsrc)) {
                    if (!empty(@$imgsrc[1])) {
                        $parts = explode(";base64,", $imgsrc[1]);
                        $imagebase64 = base64_decode($parts[1]);
                        array_push($attachment_images, array(
                            'name' => $msg->key,
                            'url' => "/" . OPE_FORM_FILE_UPLOAD_FOLDER_NAME . "/" . $year . "/" . $month . "/" . $newname,
                        ));
                        $callback = file_put_contents($target, $imagebase64);
                        if ($callback) {
                            array_push($temp_images, $target);
                            $attachments[] = $target;
                            $mail->AddAttachment($target);
                        }
                    }
                }
            }
        }
        $mail->send();
        $client_name = $client_name == '(undefined user)' ? 'false' : $client_name;
        $callBack["to"] = array("status" => "success", "code" => "Message has been sent", "name" => $client_name);
        foreach ($temp_images as $temp_img) {
            $file_pointer = $temp_img;
            if (!unlink($file_pointer)) {
                //
            } else {
                //
            }
        }
    } catch (Exception $e) {
        $callBack["to"] = array("status" => "failed", "code" => "Message could not be sent. Mailer Error: {$mail->ErrorInfo}");
        foreach ($temp_images as $temp_img) {
            $file_pointer = $temp_img;
            if (!unlink($file_pointer)) {
                //
            } else {
                //
            }
        }
    }
    /* Replyto */
    if ($client_email != '(undefined email)') {
        $mail = new PHPMailer(true);
        try {
            $mail->CharSet = 'UTF-8';
            if (OPE_FORM_SMTP == 1) {
                $mail->isSMTP(); //Send using SMTP
                $mail->Host = OPE_FORM_SMTP_HOST; //Set the SMTP server to send through
                $mail->SMTPAuth = true; //Enable SMTP authentication
                $mail->Username = OPE_FORM_SMTP_USER_NAME; //SMTP username
                $mail->Password = OPE_FORM_SMTP_PASSWORD; //SMTP password
                if (OPE_FORM_SMTP_SECURE == 1) {
                    $mail->SMTPSecure = PHPMailer::ENCRYPTION_SMTPS; //Enable implicit TLS encryption
                } else if (OPE_FORM_SMTP_SECURE == 2) {
                    $mail->SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS; //Enable implicit TLS encryption
                }
                $mail->Port = OPE_FORM_SMTP_PORT; //TCP port to connect to; use 587 if you have set `SMTPSecure = PHPMailer::ENCRYPTION_STARTTLS`
            }
            $receiver = $client_email;
            if (OPE_FORM_SMTP != 0) {
                $MAIL_FROM_ADDRESS = OPE_FORM_SMTP_USER_NAME;
            } else {
                $MAIL_FROM_ADDRESS = OPE_FORM_EMAIL_FROM_ADDRESS;
            }
            $MAIL_FROM_NAME = OPE_FORM_EMAIL_FROM_NAME;
            $mail->setFrom($MAIL_FROM_ADDRESS, $MAIL_FROM_NAME);
            $mail->addAddress($receiver);
            if (OPE_FORM_HTML_MAIL == 1) {
                if (!empty(OPE_FORM_EMAIL_REPLY_BODY_ABOVE)) {
                    $content = '<p>' . OPE_FORM_EMAIL_REPLY_BODY_ABOVE . '</p>';
                } else {
                    $content = '';
                }
                $content .= '<table
                    style="border:1px solid #ccc;border-collapse:collapse;font-size:14px;font-family: "sans-serif;">';
                foreach ($messages as $msg) {
                    $title = htmlspecialchars($msg->key);
                    $value = htmlspecialchars($msg->value);
                    $value = preg_replace('/\r|\n/', '<br>', trim($value));
                    $content .= '<tr style="border:1px solid #ccc;">
                <th style="border:1px solid #ccc;background-color:#eeeeee;font-weight:bold;min-width:100px;padding:5px 10px;white-space:nowrap;">' . $title . '</th>
                <td style="border:1px solid #ccc;background-color:#f3f3f3;font-weight:normal;padding:5px 10px;">' . $value . '</td></tr>';}
                if (!empty(OPE_FORM_EMAIL_REPLY_BODY_BELOW)) {
                    $content .= '<p>' . OPE_FORM_EMAIL_REPLY_BODY_BELOW . '</p>';
                }
            } else {
                if (!empty(OPE_FORM_EMAIL_REPLY_BODY_ABOVE)) {
                    $content = OPE_FORM_EMAIL_REPLY_BODY_ABOVE . PHP_EOL . PHP_EOL;
                } else {
                    $content = '' . PHP_EOL;
                }
                $content .= '';
                foreach ($messages as $msg) {
                    $title = htmlspecialchars($msg->key);
                    $value = htmlspecialchars($msg->value);
                    preg_match('/(\<img.*?)*(data:image\/jpeg;base64)*(\>)/', $msg->value, $img_tag);
                    if (!empty(@$img_tag)) {
                        continue;
                    }
                    $value = preg_replace('/\r|\n/', PHP_EOL, trim($value));
                    $content .= $title . '：' . $value . PHP_EOL;
                }
                if (!empty(OPE_FORM_EMAIL_REPLY_BODY_BELOW)) {
                    $content .= OPE_FORM_EMAIL_REPLY_BODY_BELOW . PHP_EOL;
                }
            }
            if (OPE_FORM_HTML_MAIL == 1) {
                $mail->isHTML(true);
            } else {
                $mail->isHTML(false);
            }
            $mail->Subject = OPE_FORM_EMAIL_REPLY_SUBJECT;
            $mail->Body = $content;
            $mail->send();
            $callBack["reply"] = array("status" => "success", "code" => "Message has been sent");
        } catch (Exception $e) {
            $callBack["reply"] = array("status" => "failed", "code" => "Message could not be sent. Mailer Error: {$mail->ErrorInfo}");
        }
    } else {
        $callBack["reply"] = array("status" => "failed", "code" => "Email not exists");
    }
    echo json_encode($callBack);
    foreach ($_SESSION as $key => $value) {
        if (strpos($key, 'captcha_code_') === 0) {
            unset($_SESSION[$key]);
        }
    }
    die();
}
